blob: 2542b38af36ffeeae3762ec3bfe78d07bc4ce54c [file] [log] [blame]
Tom Rini83d290c2018-05-06 17:58:06 -04001# SPDX-License-Identifier: GPL-2.0
Masahiro Yamada0a9064f2014-07-30 14:08:13 +09002# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +09006PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +09007 localmodconfig localyesconfig
8
Masahiro Yamada5f9eb222015-03-13 18:08:55 +09009# Added for U-Boot
10# Linux has defconfig files in arch/$(SRCARCH)/configs/,
11# on the other hand, U-Boot does in configs/.
12# Set SRCARCH to .. fake this Makefile.
13SRCARCH := ..
14
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090015ifdef KBUILD_KCONFIG
16Kconfig := $(KBUILD_KCONFIG)
17else
18Kconfig := Kconfig
19endif
20
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090021ifeq ($(quiet),silent_)
22silent := -s
23endif
24
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090025# We need this, in case the user has it in its environment
26unexport CONFIG_
27
28xconfig: $(obj)/qconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090029 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090030
31gconfig: $(obj)/gconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090032 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090033
34menuconfig: $(obj)/mconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090035 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090036
37config: $(obj)/conf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090038 $< $(silent) --oldaskconfig $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090039
40nconfig: $(obj)/nconf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090041 $< $(silent) $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090042
43silentoldconfig: $(obj)/conf
44 $(Q)mkdir -p include/config include/generated
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +090045 $(Q)test -e include/generated/autoksyms.h || \
46 touch include/generated/autoksyms.h
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090047 $< $(silent) --$@ $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090048
49localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
50 $(Q)mkdir -p include/config include/generated
51 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
52 $(Q)if [ -f .config ]; then \
53 cmp -s .tmp.config .config || \
54 (mv -f .config .config.old.1; \
55 mv -f .tmp.config .config; \
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090056 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090057 mv -f .config.old.1 .config.old) \
58 else \
59 mv -f .tmp.config .config; \
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090060 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090061 fi
62 $(Q)rm -f .tmp.config
63
64# Create new linux.pot file
65# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
66update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090067 $(Q)$(kecho) " GEN config.pot"
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090068 $(Q)xgettext --default-domain=linux \
69 --add-comments --keyword=_ --keyword=N_ \
70 --from-code=UTF-8 \
71 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
72 --directory=$(srctree) --directory=$(objtree) \
73 --output $(obj)/config.pot
74 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
75 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
76 $(srctree)/arch/*/um/Kconfig`; \
77 do \
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090078 $(kecho) " GEN $$i"; \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090079 $(obj)/kxgettext $$i \
80 >> $(obj)/config.pot; \
81 done )
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090082 $(Q)$(kecho) " GEN linux.pot"
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090083 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
84 --output $(obj)/linux.pot
85 $(Q)rm -f $(obj)/config.pot
86
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090087# These targets map 1:1 to the commandline options of 'conf'
88simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
89 alldefconfig randconfig listnewconfig olddefconfig
90PHONY += $(simple-targets)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090091
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090092$(simple-targets): $(obj)/conf
93 $< $(silent) --$@ $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090094
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +090095PHONY += oldnoconfig savedefconfig defconfig
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090096
97# oldnoconfig is an alias of olddefconfig, because people already are dependent
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +090098# on its behavior (sets new symbols to their default value but not 'n') with the
Masahiro Yamada0a9064f2014-07-30 14:08:13 +090099# counter-intuitive name.
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900100oldnoconfig: olddefconfig
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900101
102savedefconfig: $(obj)/conf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900103 $< $(silent) --$@=defconfig $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900104
105defconfig: $(obj)/conf
106ifeq ($(KBUILD_DEFCONFIG),)
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900107 $< $(silent) --defconfig $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900108else
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900109ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900110 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
111 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900112else
113 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
114 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
115endif
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900116endif
117
118%_defconfig: $(obj)/conf
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900119 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900120
Masahiro Yamada5f9eb222015-03-13 18:08:55 +0900121# Added for U-Boot (backward compatibility)
122%_config: %_defconfig
123 @:
124
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900125configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
Masahiro Yamadaad618992014-10-30 11:06:12 +0900126
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900127%.config: $(obj)/conf
128 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
129 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
130 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
Masahiro Yamadaad618992014-10-30 11:06:12 +0900131
132PHONY += kvmconfig
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900133kvmconfig: kvm_guest.config
134 @:
Masahiro Yamadaad618992014-10-30 11:06:12 +0900135
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900136PHONY += xenconfig
137xenconfig: xen.config
138 @:
139
Masahiro Yamadaad618992014-10-30 11:06:12 +0900140PHONY += tinyconfig
Masahiro Yamada9b5f0b12015-07-05 01:56:54 +0900141tinyconfig:
142 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
Masahiro Yamadaad618992014-10-30 11:06:12 +0900143
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900144# Help text used by make help
145help:
146 @echo ' config - Update current config utilising a line-oriented program'
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900147 @echo ' nconfig - Update current config utilising a ncurses menu based'
148 @echo ' program'
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900149 @echo ' menuconfig - Update current config utilising a menu based program'
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900150 @echo ' xconfig - Update current config utilising a Qt based front-end'
151 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900152 @echo ' oldconfig - Update current config utilising a provided .config as base'
153 @echo ' localmodconfig - Update current config disabling modules not loaded'
154 @echo ' localyesconfig - Update current config converting local mods to core'
155 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
156 @echo ' defconfig - New config with default from ARCH supplied defconfig'
157 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
158 @echo ' allnoconfig - New config where all options are answered with no'
159 @echo ' allyesconfig - New config where all options are accepted with yes'
160 @echo ' allmodconfig - New config selecting modules when possible'
161 @echo ' alldefconfig - New config with all symbols set to default'
162 @echo ' randconfig - New config with random answer to all options'
163 @echo ' listnewconfig - List new options'
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900164 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
165 @echo ' default value'
166# @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
167# @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
Masahiro Yamadaad618992014-10-30 11:06:12 +0900168# @echo ' tinyconfig - Configure the tiniest possible kernel'
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900169
170# lxdialog stuff
171check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
172
173# Use recursively expanded variables so we do not call gcc unless
174# we really need to do so. (Do not call gcc as part of make mrproper)
175HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
176 -DLOCALE
177
178# ===========================================================================
179# Shared Makefile for the various kconfig executables:
180# conf: Used for defconfig, oldconfig and related targets
181# nconf: Used for the nconfig target.
182# Utilizes ncurses
183# mconf: Used for the menuconfig target
184# Utilizes the lxdialog package
185# qconf: Used for the xconfig target
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900186# Based on Qt which needs to be installed to compile it
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900187# gconf: Used for the gconfig target
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900188# Based on GTK+ which needs to be installed to compile it
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900189# object files used by all kconfig flavours
190
191lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
192lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
193
194conf-objs := conf.o zconf.tab.o
195mconf-objs := mconf.o zconf.tab.o $(lxdialog)
196nconf-objs := nconf.o zconf.tab.o nconf.gui.o
197kxgettext-objs := kxgettext.o zconf.tab.o
198qconf-cxxobjs := qconf.o
199qconf-objs := zconf.tab.o
200gconf-objs := gconf.o zconf.tab.o
201
Masahiro Yamadacb6e7b02014-10-30 11:06:10 +0900202hostprogs-y := conf nconf mconf kxgettext qconf gconf
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900203
204clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
205clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900206clean-files += config.pot linux.pot
207
208# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
209PHONY += $(obj)/dochecklxdialog
210$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
211$(obj)/dochecklxdialog:
212 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
213
214always := dochecklxdialog
215
216# Add environment specific flags
217HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
218
219# generated files seem to need this to find local include files
220HOSTCFLAGS_zconf.lex.o := -I$(src)
221HOSTCFLAGS_zconf.tab.o := -I$(src)
222
223LEX_PREFIX_zconf := zconf
224YACC_PREFIX_zconf := zconf
225
226HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
227HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
228
229HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
230HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
231 -Wno-missing-prototypes
232
233HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
234
235HOSTLOADLIBES_nconf = $(shell \
Masahiro Yamadaad618992014-10-30 11:06:12 +0900236 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
237 || pkg-config --libs menu panel ncurses 2>/dev/null \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900238 || echo "-lmenu -lpanel -lncurses" )
239$(obj)/qconf.o: $(obj)/.tmp_qtcheck
240
Masahiro Yamadacb6e7b02014-10-30 11:06:10 +0900241ifeq ($(MAKECMDGOALS),xconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900242$(obj)/.tmp_qtcheck: $(src)/Makefile
243-include $(obj)/.tmp_qtcheck
244
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900245# Qt needs some extra effort...
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900246$(obj)/.tmp_qtcheck:
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900247 @set -e; $(kecho) " CHECK qt"; \
248 if pkg-config --exists Qt5Core; then \
249 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
250 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
251 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
252 elif pkg-config --exists QtCore; then \
253 cflags=`pkg-config --cflags QtCore QtGui`; \
254 libs=`pkg-config --libs QtCore QtGui`; \
255 moc=`pkg-config --variable=moc_location QtCore`; \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900256 else \
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900257 echo >&2 "*"; \
258 echo >&2 "* Could not find Qt via pkg-config."; \
259 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
260 echo >&2 "*"; \
261 exit 1; \
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900262 fi; \
263 echo "KC_QT_CFLAGS=$$cflags" > $@; \
264 echo "KC_QT_LIBS=$$libs" >> $@; \
265 echo "KC_QT_MOC=$$moc" >> $@
266endif
267
268$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
269
Masahiro Yamadacb6e7b02014-10-30 11:06:10 +0900270ifeq ($(MAKECMDGOALS),gconfig)
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900271-include $(obj)/.tmp_gtkcheck
272
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900273# GTK+ needs some extra effort, too...
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900274$(obj)/.tmp_gtkcheck:
275 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
276 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
277 touch $@; \
278 else \
279 echo >&2 "*"; \
280 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
281 echo >&2 "*"; \
282 false; \
283 fi \
284 else \
285 echo >&2 "*"; \
286 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
287 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
288 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
289 echo >&2 "*"; \
290 false; \
291 fi
292endif
293
294$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
295
296$(obj)/qconf.o: $(obj)/qconf.moc
297
298quiet_cmd_moc = MOC $@
299 cmd_moc = $(KC_QT_MOC) -i $< -o $@
300
301$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
302 $(call cmd,moc)
303
Masahiro Yamadabf7ab1e2017-02-11 12:39:54 +0900304# Extract gconf menu items for i18n support
Masahiro Yamada0a9064f2014-07-30 14:08:13 +0900305$(obj)/gconf.glade.h: $(obj)/gconf.glade
306 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
307 $(obj)/gconf.glade